%define section free

# If you do not want to build samples in demo subpackage because of their 
# runtime deps, give rpmbuild option '--without demo'
%define with_demo %{!?_without_demo:1}%{?_without_demo:0}

Name:		xdoclet
Version:	1.2.1
Release:	1jpp
Epoch:		0
Summary:	XDoclet Attribute Orientated Programming Framework
License:	XDoclet Open Source Licence
Group:		Development/Framework
Vendor:		JPackage Project
Distribution:	JPackage
URL:		http://xdoclet.sourceforge.net
Source0:	%{name}-src-%{version}.tgz
# maven-generated docs:
Source1:	%{name}-doc-%{version}.tar.gz
Patch0:		xdoclet-build_xml.patch
Patch1:		xdoclet-XDocletModulesEjbMessages.patch
Patch2:		xdoclet-ant.not-required.patch
BuildArch:	noarch
BuildRoot: 	%{_tmppath}/%{name}-root
BuildRequires:  java-devel
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.5
BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  jrefactory
BuildRequires:  bsf 
BuildRequires:  jakarta-commons-collections 
BuildRequires:  jakarta-commons-logging 
BuildRequires:  log4j
BuildRequires:  mockobjects 
BuildRequires:  mx4j 
BuildRequires:  servletapi4 
BuildRequires:  struts 
BuildRequires:  velocity 
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-apis 
BuildRequires:  xjavadoc = 0:1.0.3
#
Requires:  bsf
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-logging
Requires:  log4j
Requires:  mockobjects
Requires:  velocity
Requires:  xalan-j2
Requires:  xml-commons-apis
Requires:  xjavadoc = 0:1.0.3

%description
This package contains the XDoclet Attribute Orientated Programming Framework

%if %{with_demo}
%package demo
Summary:	XDoclet Sample Projects
Group:		Development/Framework
BuildRequires:  servletapi4
BuildRequires:  struts
BuildRequires:  velocity
BuildRequires:  webwork
BuildRequires:  jndi
BuildRequires:  ejb
BuildRequires:  jms
BuildRequires:  mx4j
Requires:  %{name} = %{version}-%{release}
Requires:  ejb
Requires:  jms
Requires:  webwork
Requires:  jndi
Requires:  mx4j
Requires:  struts
Requires:  servletapi4

%description demo
This package contains sample XDoclet projects.
%endif

%package javadoc
Summary:	XDoclet Javadoc
Group:		Development/Documentation

%description javadoc
This package contains XDoclet javadoc

%package manual
Summary:	XDoclet Sample Manuals and Documentation
Group:		Development/Documentation

%description manual
This package contains XDoclet documentation.

%prep
%setup -q
cp core/build.xml core/build.xml.sav
cp modules/modules-common.ent modules/modules-common.ent.sav

find . -name "*.jar" -exec rm {} \;

for j in xjavadoc-1.0.3 jrefactory javacc junit bsf commons-collections commons-logging log4j velocity xalan-j2 xjavadoc xml-commons-apis mockobjects-core; do
	ln -s $(find-jar $j) lib/$j.jar
done

%if %{with_demo}
for j in servletapi4 struts velocity webwork ejb jms; do
	ln -s $(find-jar $j) samples/lib/$j.jar
done
for j in mx4j/mx4j-jmx mx4j/mx4j-tools mx4j/mx4j-actions; do
        i=$(find-jar $j)
	ln -s $i samples/lib/$(basename $i)
done
%endif

%patch0
%patch1
%patch2

%build
ant core modules maven docs l10n
%if %{with_demo}
ant samples
%endif
# unpack maven-generated documents
gzip -dc %{SOURCE1} | tar -xf -

%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/lib/xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/lib/maven-xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%if %{with_demo}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%endif

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/api

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%files
%defattr(-, root, root, -)
%{_javadir}/%{name}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt

%if %{with_demo}
%files demo
%{_datadir}/%{name}-%{version}
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}

%files manual
%doc %{_docdir}/%{name}-%{version}

%changelog

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-1jpp
- Upgrade to 1.2.1
- Relax build-time dependencies
- Relax dependency versions
- Make subpackage xdoclet-demo optional

* Fri Mar 05 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2-1jpp
- First JPackage release.

